<template>
    <div class="image-upload-wrapper image-upload">
        <div id="croppie"></div>

        <div id="upload-wrapper">
        	<button class="btn btn-warning btn-flat btn-sm" @click="toggle">
        		<i class="icon ion-ios-camera-outline"></i>&nbsp;تغيير الصورة
        	</button>

			<div class="image-modal" v-if="modalVisible">
	        	<input type="file" 
                       accept="image/*"
                       @change="setupFileUploader"
                       style="display:none"
                       ref="fileInput"
                       >

                <button class="btn btn-success btn-flat btn-sm btn-action" @click="$refs.fileInput.click()">
                    <i class="icon ion-ios-camera-outline"></i>&nbsp;اختر الصورة
                </button>

	        	<button class="btn btn-info btn-flat btn-sm btn-action" @click="uploadFile">
	        		<i class="icon ion-ios-upload-outline"></i>&nbsp;رفع
	        	</button>

	        	<button class="btn btn-default btn-flat btn-sm btn-action" @click="modalVisible = false">
	        		<i class="icon ion-ios-close-outline"></i>&nbsp;إلغاء
	        	</button>
	        </div>
        </div>

        
    </div>
</template>

<script>
    import {baseUrl} from './../../config'
	import Croppie from 'croppie'

    export default {
        props: ['imgUrl', 'id'],

        mounted () {
	      	this.$on('imgUploaded', function (imageData) {
	      		this.image = imageData
	      		this.croppie.destroy()
	      		this.setupCroppie(imageData)
	      	})
        	this.image = this.imgUrl
        	this.setupCroppie()
        },

        data () {
        	return {
        		image: null,
        		croppie: null,
        		modalVisible: false
        	}
        },

        methods: {
            toggle () {
                if (this.modalVisible == false) {
                    this.modalVisible = true
                } 
                else {
                    this.modalVisible = false
                }
            },

        	setupCroppie () {
        		let el = document.querySelector('#croppie')
        		this.croppie = new Croppie.Croppie(el, {
        			viewport: { width:200, height:200, type: 'circle' },
        			boundary: { width:220, height:220 },
        			showZoomer: true,
        			enableOrientation: true
        		})
        		this.croppie.bind({
        			url: this.image
        		})
        	},

        	setupFileUploader(e) {
        		let files = e.target.files || e.dataTransfer.files
		        if (!files.length) {
		          return
		        }
		        this.createImage(files[0])
        	},

        	createImage (file) {
        		var image = new Image()
        		var reader = new FileReader()
        		var vm = this

        		reader.onload = (e) => {
		          vm.image = e.target.result
		          vm.$emit('imgUploaded', e.target.result)
		        }

		        reader.readAsDataURL(file)
        	},

        	uploadFile() {
        		this.croppie.result({
		          type: 'canvas',
		          size: 'viewport'
		        }).then(response => {
		        	this.image = response
		        	axios.post(baseUrl + '/api/v1/image-upload', { img: this.image, id: this.id })
		        		 .then(response => {
		        		 	this.modalVisible = false
		        		 })
		        })
        	}
        }
    }
</script>

<style lang="scss">
  .image-upload {
    .image-modal {
      border-top: 1px solid #f4f4f4;
      margin-top: 10px;
      padding-top: 10px;
    }
    div#upload-wrapper {
      text-align: center;
    }
    .btn-action {
    	padding: 5px 20px;
    }
  }
</style>
